<template>
  
    <div class="d-md-flex p-4 pt-2 mt-3  flex-wrap justify-content-center align-items-center contenedorPrincipal">
      <div class="d-md-flex  ms-md-3 ms-0 mt-3">
        <label for="liquidacion" class="form-label me-0 me-md-2" style="margin-top: 2px !important">Liquidación:</label>
        <auto-complete required v-model="data.liquidaciones" :elements="liquidacionesStore.listadoLiquidaciones"
          initKey="" placeholder="Seleccionar periodo" :minLength="2" :disabled="false" id="liquidaciones" />
      </div>

      <div  class="ms-0 ms-md-3 mt-3 mt-md-0" v-show="data.liquidaciones != null">
          <a  @click="generarArchivo" target="_blank" title="GENERAR" alt="GENERAR"
            class="btn btn-principal p-1 px-2 mt-3 mt-md-3 me-md-2 me-2">
            <i class="fa-solid fa-print me-1"></i> GENERAR ARCHIVO
          </a>
         
          <a :href="listadoExcel()
            " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal p-1 px-2 mt-3 mt-md-3  me-md-2 me-0">
            <i class="fa-solid fa-print me-1"></i> Bajada Exel 
          </a>

          <a   :href="listadoPDF()
            " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal p-1 px-2 mt-3 mt-md-3  me-md-2 me-0">
            <i class="fa-solid fa-print me-1"></i> Bajada Pdf 
          </a>
      </div>
    </div>
  
</template>

<script setup lang="ts">
import { onMounted, reactive } from "vue";
import { AutoComplete, isEmpty } from "@hcd-bsas/vue3-components";
import { useRouter } from "vue-router";
import http from "@/http";
import { urlApi, loading, getUrl } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
// Stores
import { useLiquidacionesStore } from "@/stores/Liquidaciones/liquidaciones";
//entitie
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";

const router = useRouter();
const liquidacionesStore = useLiquidacionesStore();

var data = reactive({
  liquidaciones: undefined as Liquidacion | undefined,
});

async function generarArchivo() {
  const paramsRequest: any = {};
  paramsRequest.id_liq_resu = data.liquidaciones?.id_liq_resu;
  loading.show();
  try {
    //hay que validar que el nombre no empiece con ENTE y que ademas , si el array no parseo nada, que tire error . (como validar el array por linea RARO)
    const response = await http.post(urlApi + "armarArchivoSafin", {}, { params: { id_liq_resu: paramsRequest.id_liq_resu } });
    if (response.status == 200) {
      let blob = new Blob([response.data.file], { type: 'text/plain' });
      let url = URL.createObjectURL(blob);
      let link = document.createElement('a');
      link.download = response.data.filename;
      link.href = url;
      link.click();
      Swal.fire({
        icon: 'success',
        title: 'Exito',
        text: "Archivo Generado con exito",
      });
    }
  } catch (error: any) {
    Swal.fire({
      icon: 'error',
      title: 'Error',
      text: error.response.data.message_error,
    });
  }
  loading.hide();
}

function listadoExcel() {
  var queryParams: any = {
    id_liq_resu : isEmpty(data.liquidaciones) ? null : data.liquidaciones?.id_liq_resu,
    tipo : 'XLS'
  }
  return getUrl('imprimirBajaSafin', [], queryParams);
}

function listadoPDF() {
  var queryParams: any = {
    id_liq_resu : isEmpty(data.liquidaciones) ? null : data.liquidaciones?.id_liq_resu,
    tipo : 'PDF'
  }
  return getUrl('imprimirBajaSafin', [], queryParams);
}

onMounted(async () => {
  loading.show();
  liquidacionesStore.updateListadoLiquidaciones();
  loading.hide();
})

</script>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
